package cs131w.assembly;



import cs131w.parser.*;



public class Regs implements Asmbl {

	//local l1 - 5
	private static boolean[] m_used = {false,false,false,false,false};

	//float f1 - 30
	private static boolean[] m_fl_used = {false,false,false,false,false,false,false,false,false,false,
										  false,false,false,false,false,false,false,false,false,false,
										  false,false,false,false,false,false,false,false,false,false};
	
	public Regs(){ }

	public static String
	getNextReg(){
		
		for (int i = 0; i < 5; i++){
			if (m_used[i] == false){
				m_used[i] = true;
				//AssemblyWriter.writeSmtAndComment("reserving " + "%l" + (i+1), "", "");
				return ("%l" + (i+1));
			}
		}
		
		return "%l-1";
	}

	public static void
	FreeReg(String r){
		if(null == r || r.length() < 3) return;
		
		
		char [] a = r.toCharArray();
		int num = new Integer(r.substring(2)).intValue() - 1;
		switch (a[1]){
			case 'l':
				if(0 <= num && num < 5){
					m_used[num] = false;
					//AssemblyWriter.writeSmtAndComment("clearing " + r + ", reg no. " + num, "", "");
				}
				break;
			case 'f':
				if(0 <= num && num < 30){
					m_fl_used[num] = false;
				}
				break;
			default: 
				MyParser.debug("Not clearing reg: " + r);
		}
	}
	
/*	public static boolean
	ReserveReg(String r){
		if(null == r) return false;
		
		if (r.substring(1, 2) != "l") return false;
		
		int num = new Integer(r.substring(2)).intValue();
		
		if(m_used[num] == true) return false;
		
		m_used[num] = true; 
		return true;
	}*/

	public static String
	getNextFloatReg(){
		
		for (int i = 0; i < 30; i++){
			if (m_fl_used[i] == false){
				m_fl_used[i] = true;
				return ("%f" + (i+1));
			}
		}
		
		return "%f-1";
	}

	public static void
	FreeFloatReg(String r){
		if (r.substring(1, 2) != "f") return;
		
		int num = new Integer(r.substring(2)).intValue();
		m_fl_used[num] = false;
	}

	public static void clearIntRegs(){
		for (boolean b: m_used){
			b = false;
		}
	}
	
	public static void clearFloatRegs(){
		for (boolean b: m_fl_used){
			b = false;
		}
	}
	
	public static void printRegStatusComment(){
		StringBuilder sb = new StringBuilder(Asmbl.COMMENT + "Regs: ");
		for (boolean b: m_used){
			sb.append(b + ", ");
		}
		AssemblyWriter.writeSmtAndComment(sb.toString(), "", "");
	}

}