package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class AmperOp extends BitwiseOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	AmperOp ()
	{
		super("&", new Token (sym.T_AMPERSAND, "&"));
		m_Template = AND;
	}

	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res;
		
		//already checked that both are int
		res = new ConstSTO( a.getIntValue() & b.getIntValue() );
		
		res.setRVal();
		return res;
	}
	
	
}