package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public abstract class BinaryOp extends Operator{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	BinaryOp ()
	{
		super("", null);
	}
	

	public 
	BinaryOp (String strName, Token tok)
	{
		super(strName, tok);
	}

	public STO operate(STO a, STO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res = new ExprSTO("modop", new IntType());
		res.setRVal();
		return res;
	}
	
}