package cs131w.symtab.sto;
//---------------------------------------------------------------------
//	Empty Type is basically just for passing up a name where there is
//	an STO expected
//---------------------------------------------------------------------
import  cs131w.symtab.types.*;

public class EmptySTO extends STO
{
	//----------------------------------------------------------------
	//	Empty STO is empty, and should have the JokerType set, if possible
	//	so it can be any type
	//----------------------------------------------------------------
	public 
	EmptySTO ()
	{
		this ("empty");
	}

	public 
	EmptySTO (String strName)
	{
		this (strName, new VoidType());
	}

	public 
	EmptySTO (Type t)
	{
		this ("empty", t);
	}

	public 
	EmptySTO (String strName, Type t)
	{
		super (strName, t);
		setModLVal();
	}

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public boolean	isEmpty () 	{ return true; }

/*
	//Empty STO has the size of underlying type!
	public int
	getSize(){
		return 0;
	}	
*/	
}
