package cs131w.symtab.types;
import 	cs131w.parser.MyParser;


public class FuncPtrType extends PtrType
{
	
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	FuncPtrType (FuncProtoType ret)
	{
		//a funcptr does not have any derefs
		super("funcptr", 4, ret, 0);
	}
	
	public boolean isEquivalent(Type t){
		//MyParser.debug("funcptr("+this+") checking equiv of "+t+ ", isFunc: "+(t.getRootType().isFunction()));
		
		//check if the passed type is a function
		if (t.getRootType().isFunction()){
			return this.getPointedToType().isEquivalent(t.getRootType());
		}
		
		return false;
	}

	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isFuncPtr ()		{ return true; }
	
	
}