package cs131w.symtab.types;


public class IntType extends NumType
{
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	IntType ()
	{
		super("int",4);
	}

	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isInt ()		{ return true; }


	//----------------------------------------------------------------
	// int is the only type that is coercible to float, 
	// so indicate that here
	//----------------------------------------------------------------
	public boolean isAssignable(Type t){
		if (t == null) return false;
		
		if (super.isAssignable(t) || t.isFloat()) return true;
		else return false;
	}	
	
}
