package cs131w.util;
//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
import java.util.Vector;
import  cs131w.parser.MyParser;
import  cs131w.symtab.sto.*;


public class Utils
{
	public static int LABEL_COUNTER = 1;
	//----------------------------------------------------------------
	// gets a unique mangled name from a vector of call STOs
	//----------------------------------------------------------------
	public static String
	getMangledNameFromVector(Vector v)
	{
		final StringBuilder sb = new StringBuilder();
		STO sto;
		//append each param in order
		for (int i = 0; i < v.size (); i++)
		{
			sto = (STO) v.elementAt (i);
			sb.append( "_$" + sto.getMangledName());
		}
	
//		MyParser.debug("Utils.getMangledNameFromVec() returning: '" + sb + "'");
		return sb.toString();
	}
	
	public static String strRepeat(String s, int n) {
		if (n==1) return s;
	    final StringBuilder sb = new StringBuilder();
	    for(int i = 0; i < n; i++) {
	        sb.append(s);
	    }
	    return sb.toString();
	}
	
	public static String getSomeLabel(String prefix){
		return prefix + (++LABEL_COUNTER)  + "$L" + MyParser.GetLineNum();
	}

	

}