package cs131w.symtab.types;


public class NullType extends Type
{
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	NullType ()
	{
		super("null",0);
	}

	//null is not equivalent to nothing not even itself
	public boolean isEquivalent(Type t){
		return false;
	}
	
	//but is assignable to a pointer type
	public boolean isAssignable(Type t){
		
		if (t.getRootType().isPtr())
			return true;
			
		return false;
	}
	
	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isNull ()	{ return true; }
	
	
}