package cs131w.symtab.types;


public class StringType extends CompType
{

	//length
	private int			m_len;
	private static int 	ms_sizeofchar = 1;
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	StringType ()
	{
		this("");
	}

	public 
	StringType (String strName)
	{
		super("string", strName.length() * ms_sizeofchar);
		m_len = strName.length();
	}


	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public int
	getLength(){
		return m_len;
	}

	protected void
	setLength(int l){
		m_len = l;
	}

	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isString ()		{ return true; }


	
}