package cs131w.symtab.types;
import cs131w.parser.MyParser;


public class VoidType extends Type
{
	
	//----------------------------------------------------------------
	// this is the empty type, that is void
	//----------------------------------------------------------------
	public 
	VoidType ()
	{
		super("void",0);
	}

	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isVoid ()	{ return true; }

	public boolean isAssignable(Type t){
		//MyParser.debug(this + ".isAssignable() to " + t);
		
		//void is assignable to any pointer type
		if (t == null || !t.isPtr()) return false;
		return true;
	}	
	
	
}